﻿using NHibernate;
using ThinkNet.Infrastructure;


namespace ThinkNet
{
    public static class BootstrapperExtentions
    {
        public static Bootstrapper MappingAssembly(this Bootstrapper that, string assemblyName)
        {
            NHibernateSessionFactory.BuildSessionFactory(assemblyName);

            return that;
        }

        public static Bootstrapper RegisterSession(this Bootstrapper that, LifetimeStyle lifeStyle = LifetimeStyle.Transient)
        {
            return that.Register<ISession>(NHibernateSessionFactory.Instance.OpenSession(), lifeStyle);
        }

        public static Bootstrapper RegisterRepositoryContext(this Bootstrapper that, LifetimeStyle lifeStyle = LifetimeStyle.PerRequest)
        {
            return that.Register<IRepositoryContext, NHibernateRepositoryContext>(lifeStyle);
        }
    }
}
