﻿using System;
using System.Configuration;
using Microsoft.Practices.Unity;
using Microsoft.Practices.Unity.Configuration;
using Microsoft.Practices.Unity.InterceptionExtension;

using ThinkNet.Infrastructure;


namespace ThinkNet
{
    public static class BootstrapperExtentions
    {
        public static Bootstrapper UseUnityContainer(this Bootstrapper that)
        {
            var container = new UnityContainer();
            container.AddNewExtension<Interception>();

            return that.UseUnityContainer(container);
        }

        public static Bootstrapper UseUnityContainerWithConfig(this Bootstrapper that, string name)
        {
            name.MustNotEmpty("name");

            var section = (UnityConfigurationSection)ConfigurationManager.GetSection(name);
            var container = section.Configure(new UnityContainer());

            return that.UseUnityContainer(container);
        }

        public static Bootstrapper UseUnityContainer(this Bootstrapper that, IUnityContainer container)
        {
            container.MustNotNull("container");

            return that.SetContainer(new UnityObjectContainer(container));
        }
    }
}
