﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ThinkNet.Test.Domain;
using ThinkNet.Test.Infrastructure;
using ThinkNet.Infrastructure;

namespace ThinkNet.Test.Application
{
    [ParticipateInContainer(LifetimeStyle.Transient, typeof(IUserService))]
    public class UserService : IUserService
    {
        private readonly IUserRepository _userRepository;

        public UserService(IUserRepository userRepository)
            : base()
        {
            this._userRepository = userRepository;
        }

        public IEnumerable<UserDTO> GetAllUsers()
        {
            return _userRepository.GetAll().Select(user => new UserDTO {
                LoginId = user.LoginId,
                Password = user.Password,
                UserID = user.Id,
                UserName = user.UserName
            }).ToArray();
        }

        public UserDTO GetUserByLogon(string loginId, string password, string clientIp)
        {
            Console.WriteLine("调用验证方法");

            var user = _userRepository.CheckLogon(new User {
                LoginId = loginId,
                Password = password
            });

            if (user == null)
                return null;

            user.LogonToLog(clientIp);

            return new UserDTO {
                UserID = user.Id,
                LoginId = user.LoginId,
                Password = user.Password,
                UserName = user.UserName
            };
        }
    }
}
