﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ThinkNet.Event;
using ThinkNet.Test.Domain;
using ThinkNet.Domain;
using ThinkNet.Test.Infrastructure;

namespace ThinkNet.Test.Events
{
    public class UserEventHandler : IEventHandler<UserCreated>, IEventHandler<UserLogined>
    {
        private readonly IUserRepository _userRepository;
        private readonly ICache _domainCache;
        public UserEventHandler(ICache domainCache, IUserRepository userRepository)
        {
            this._userRepository = userRepository;
            this._domainCache = domainCache;
        }

        public void Handle(UserCreated @event)
        {
            var user = (User)_domainCache.Get(@event.UserID, typeof(User));
            _userRepository.Save(user);
            _userRepository.UnitOfWork.Commit();

            Console.WriteLine("同步到Q端数据库");
        }

        public void Handle(UserLogined @event)
        {
            Console.WriteLine("记录登录日志");
        }
    }
}
