﻿using System;
using Microsoft.Practices.Unity;
using Microsoft.Practices.Unity.InterceptionExtension;

namespace ThinkNet.Test.Infrastructure
{
    public class InterceptHandler : ICallHandler
    {
        public IMethodReturn Invoke(IMethodInvocation input, GetNextHandlerDelegate getNext)
        {
            Console.WriteLine("方法开始前拦截");

            var realReturn = getNext()(input, getNext);

            Console.WriteLine("方法开始后拦截");

            return realReturn;
        }

        public int Order { get; set; }
    }

    [AttributeUsage(AttributeTargets.Class | AttributeTargets.Interface | AttributeTargets.Method | AttributeTargets.Property)]
    public class InterceptHandlerAttribute : HandlerAttribute
    {
        public override ICallHandler CreateHandler(IUnityContainer container)
        {
            return new InterceptHandler();
        }
    }
}
