﻿using System.Collections.Generic;
using ThinkNet.Infrastructure;
using ThinkNet.Test.Domain;

namespace ThinkNet.Test.Infrastructure
{
    [ParticipateInContainer(LifetimeStyle.PerRequest, typeof(IUserRepository))]
    public class UserRepository : Repository<User>, IUserRepository
    {
        public bool ExistsByLoginId(string loginId)
        {
            var query = Criteria<User>.Eval(p => p.LoginId == loginId);

            return base.Exists(query);
        }


        public User CheckLogon(User user)
        {
            var query = Criteria<User>.Eval(p => p.LoginId == user.LoginId)
                .And(p => p.Password == user.Password);

            return base.Single(query);
        }


        public new IEnumerable<User> GetAll()
        {
            return base.GetAll();
        }
    }
}
