﻿using System;
using System.Linq;
using System.Reflection;
using System.Threading;

using ThinkNet.Command;
using ThinkNet.Infrastructure;
using ThinkNet.Test.Commands;
using ThinkNet.Test.Domain;
using ThinkNet.Test.Infrastructure;
using ThinkNet.Test.Application;
using ThinkNet.Domain;

namespace ThinkNet.Test
{
    class Program
    {
        static void Main(string[] args)
        {
            Action[] actions = new Action[10];
            for (int i=0; i < actions.Length; i++) {
            }


            Bootstrapper.Current
                .Load(Assembly.GetExecutingAssembly())
                //.UseDefaultContainer()
                .UseUnityContainer()
                .Register<IRepositoryContext, MemoryRepositoryContext>(LifetimeStyle.PerThread)
                //.Register<IUserRepository, UserRepository>(LifetimeStyle.Transient)
                //.Register<IUserService, UserService>(LifetimeStyle.Transient)
                .RegisterDefaultComponents()
                .RegisterBusinessComponents()
                .CreateCommandProcessors(new string[] { "CommandQueue" })
                .CreateEventProcessors(new string[] { "EventQueue" })
                .Run();


            var userRegister = new RegisteringUser {
                UserName = "老韩",
                Password = "hanyang",
                LoginId = "young.han",
                Email = "19126332@qq.com"
            };


            CommandService.Instance.Send(userRegister);


            //if (result.IsCompleted) {
            //    Console.WriteLine("发送邮件");
            //}
            //else {
            //    Console.WriteLine("错误");
            //}


            Thread.Sleep(1000);

            //var cache = ServiceLocator.GetInstance<ICache>();


            var userService = ServiceLocator.GetInstance<IUserService>();

            var count = userService.GetAllUsers().Count();
            Console.WriteLine("共有 " + count + " 个用户。\r\n");

            var user = userService.GetUserByLogon("young.han", "hanyang", "127.0.0.1");
            if (user == null) {
                Console.WriteLine("用户名或密码错误");
            }
            else {
                Console.WriteLine(string.Concat("登录成功。", "用户名称：", user.UserName));
            }

            

            Console.Read();
        }
    }
}
