﻿using System;
using System.Threading;
using ThinkNet.Infrastructure;

namespace ThinkNet.Command
{
    /// <summary>
    /// 表示命令执行异步的结果。
    /// </summary>
    public class CommandAsyncResult
    {
        //private readonly ManualResetEvent _waitHandle;
        private readonly Action<CommandAsyncResult> _callback;

        /// <summary>
        /// 获取命令是否执行完成。
        /// </summary>
        public bool IsCompleted { get; private set; }
        ///// <summary>Represents the id of aggregate root which was created or updated by the command.
        ///// <remarks>Can be null if the command not effect any aggregate root.</remarks>
        ///// </summary>
        //public object AggregateRootId { get; private set; }
        /// <summary>
        /// 执行命令时产生的错误消息。
        /// </summary>
        public ErrorInfo ErrorInfo { get; private set; }

        ///// <summary>Parameterized constructor.
        ///// </summary>
        ///// <param name="waitHandle"></param>
        //public CommandAsyncResult(ManualResetEvent waitHandle)
        //{
        //    waitHandle.MustNotNull("waitHandle");

        //    _waitHandle = waitHandle;
        //}
        /// <summary>Parameterized constructor.
        /// </summary>
        /// <param name="callback"></param>
        public CommandAsyncResult(Action<CommandAsyncResult> callback)
        {
            callback.MustNotNull("callback");

            _callback = callback;
        }

        /// <summary>
        /// 完整的执行异步命令后的结果。
        /// </summary>
        /// <param name="errorInfo"></param>
        public void Complete(/*object aggregateRootId, */ErrorInfo errorInfo)
        {
            this.IsCompleted = errorInfo == null;
            //this.AggregateRootId = aggregateRootId;
            this.ErrorInfo = errorInfo;

            //if (_waitHandle != null) {
            //    _waitHandle.Set();
            //}
            //else if (_callback != null) {
            //    _callback(this);
            //}
            if (_callback != null) {
                _callback(this);
            }
        }
    }
}
