﻿
namespace ThinkNet.Command
{
    /// <summary>
    /// 命令处理程序接口。
    /// </summary>
    public interface ICommandHandler
    {
        /// <summary>Handles the given command.
        /// </summary>
        /// <param name="command"></param>
        void Handle(ICommand command);

        /// <summary>Returns the inner really command handler.
        /// </summary>
        /// <returns></returns>
        object GetInnerCommandHandler();
    }

    /// <summary>
    /// 表示实现该接口的类型为命令处理器
    /// </summary>
    /// <typeparam name="TCommand"></typeparam>
    public interface ICommandHandler<in TCommand>
        where TCommand : class, ICommand
    {
        /// <summary>
        /// 处理命令
        /// </summary>
        /// <param name="command"></param>
        void Handle(TCommand command);
    }
}
