﻿using System;


namespace ThinkNet.Database
{
    [AttributeUsage(AttributeTargets.Property | AttributeTargets.Field, AllowMultiple = false, Inherited = true)]
    public abstract class FieldActiveAttribute : Attribute
    {
        protected FieldActiveAttribute(DbActiveType activeType)
        {
            this.ActiveType = activeType;
        }

        /// <summary>
        /// 与数据库操作状态
        /// </summary>
        public DbActiveType ActiveType { get; private set; }
    }
}
