﻿using System;

namespace ThinkNet.Database
{
    /// <summary>
    /// 实体属性映射到表字段的类
    /// </summary>
    [AttributeUsage(AttributeTargets.Property | AttributeTargets.Field)]
    public sealed class FieldMappingAttribute : Attribute
    {
        /// <summary>
        /// 使用字段名称来初始化 <see cref="FieldMappingAttribute"/> 类的新实例。
        /// </summary>
        /// <param name="fieldName">字段名称</param>
        public FieldMappingAttribute(string fieldName)
        {
            this.FieldName = fieldName;
        }

        /// <summary>
        /// 映射的字段名称
        /// </summary>
        public string FieldName { get; private set; }
    }
}
