﻿using System;


namespace ThinkNet.Database
{
    [AttributeUsage(AttributeTargets.Class | AttributeTargets.Interface)]
    public sealed class TableMappingAttribute : Attribute
    {
        /// <summary>
        /// 使用表名称来初始化 <see cref="TableMappingAttribute"/> 类的新实例。
        /// </summary>
        /// <param name="fieldName">表名称</param>
        public TableMappingAttribute(string tableName)
        {
            this.TableName = tableName;
        }

        /// <summary>
        /// 映射的表名称
        /// </summary>
        public string TableName { get; private set; }
    }
}
