﻿using System;

namespace ThinkNet.Database
{
    /// <summary>
    /// 用于向数据库中添加/修改的数据类
    /// </summary>
    public class SqlData
    {
        public SqlData(string name, int value)
            : this(name, (object)value)
        { }

        public SqlData(string name, decimal value)
            : this(name, (object)value)
        { }

        public SqlData(string name, DateTime value)
            : this(name, (object)value)
        { }

        public SqlData(string name, string value)
            : this(name, (object)value)
        { }

        public SqlData(string name, object value)
        {
            this.Name = name;
            this.Value = value;
        }

        internal static SqlData CreateSafety(string name, string value)
        {
            return new SqlData(name, value) {
                Safety = true
            };
        }

        internal bool Safety { get; set; }

        /// <summary>
        /// 值
        /// </summary>
        public object Value
        {
            get;
            protected internal set;
        }


        /// <summary>
        /// 名称
        /// </summary>
        public string Name
        {
            get;
            protected internal set;
        }
    }
}
