﻿
namespace ThinkNet.Database
{
    /// <summary>
    /// 查询字段
    /// </summary>
    public class SqlField : SqlGroup
    {
        protected internal SqlField()
        { }

        /// <summary>
        /// 用字段名称构造实例
        /// </summary>
        /// <param name="name">字段名称</param>
        public SqlField(string name)
            : this(name, null)
        { }
        /// <summary>
        /// 用字段名称和别名构造实例
        /// </summary>
        /// <param name="name">字段名称</param>
        /// <param name="alias">别名</param>
        public SqlField(string name, string alias)
            : this(DbAggrefunc.NONE, name, alias)
        { }
        /// <summary>
        /// 用合计函数类型和字段名称构造实例
        /// </summary>
        /// <param name="func">合计函数类型</param>
        /// <param name="name">字段名称</param>
        public SqlField(DbAggrefunc func, string name)
            : this(func, name, null)
        { }
        /// <summary>
        /// 用合计函数类型、字段名前缀和字段名称构造实例
        /// </summary>
        /// <param name="func">合计函数类型</param>
        /// <param name="name">字段名称</param>
        /// <param name="alias">别名</param>
        public SqlField(DbAggrefunc func, string name, string alias)
            : base(name)
        {
            this.Aggrefunc = func;
            this.Alias = alias;
        }


        /// <summary>
        /// 合计函数
        /// </summary>
        public DbAggrefunc Aggrefunc { get; protected internal set; }

        /// <summary>
        /// 别名
        /// </summary>
        public string Alias { get; internal set; }
    }
}
