﻿using System;

namespace ThinkNet.Database
{
    /// <summary>
    /// 表示未包含在聚合函数的列
    /// </summary>
    public class SqlGroup
    {
        protected internal SqlGroup()
        { }

        /// <summary>
        /// 使用列名称构造实例
        /// </summary>
        /// <param name="name">列名称</param>
        public SqlGroup(string name)
        {
            name.MustNotEmpty("name");

            this.FieldName = name;

            string[] array = name.Split('.');

            if (array.Length > 1) {
                this.Prefix = array[0];
                this.Name = array[1];
            }
            else {
                this.Name = name;
            }
        }


        /// <summary>
        /// 获取列名称
        /// </summary>
        public string FieldName { get; protected internal set; }


        internal string Prefix { get; set; }

        internal string Name { get; set; }
    }
}
