﻿
namespace ThinkNet.Database
{
    public class SqlHaving : SqlWhere
    {
        protected internal SqlHaving()
        { }

        public SqlHaving(DbAggrefunc func, string name, object value)
            : this(func, name, DbJudgeSymbol.EQ, value)
        { }


        public SqlHaving(DbAggrefunc func, string name, DbJudgeSymbol symbol, object value)
            : this(DbLogical.And, func, name, symbol, value)
        { }


        public SqlHaving(DbLogical logical, DbAggrefunc func, string name, object value)
            : this(logical, func, name, DbJudgeSymbol.EQ, value)
        { }

        public SqlHaving(DbLogical logical, DbAggrefunc func, string name, DbJudgeSymbol symbol, object value)
            : base(logical, name, symbol, value)
        {
            if (func == DbAggrefunc.NONE)
                throw new System.NotSupportedException();

            this.Aggrefunc = func;
        }
    }
}
