﻿
namespace ThinkNet.Database
{
    /// <summary>
    /// 用于排序的列
    /// </summary>
    public class SqlOrder : SqlGroup
    {
        protected internal SqlOrder()
        { }

        /// <summary>
        /// 使用字段名称和排序方式创建新实例。
        /// </summary>
        /// <param name="name">字段名称</param>
        /// <param name="orderType">排序方式枚举</param>
        public SqlOrder(string name, DbOrderType orderType)
            : base(name)
        {
            this.OrderType = orderType;
        }

        /// <summary>
        /// 排序规则
        /// </summary>
        public DbOrderType OrderType { get; internal set; }
    }
}
