﻿
namespace ThinkNet.Database
{
    public enum DbLogical
    {
        And,
        Or
    }

    public class SqlWhere : SqlGroup
    {
        protected internal SqlWhere()
        { }

        public SqlWhere(string name, object value)
            : this(name, DbJudgeSymbol.EQ, value)
        { }


        public SqlWhere(string name, DbJudgeSymbol symbol, object value)
            : this(DbLogical.And, name, symbol, value)
        { }



        public SqlWhere(DbLogical logical, string name, object value)
            : this(logical, name, DbJudgeSymbol.EQ, value)
        { }


        public SqlWhere(DbLogical logical, string name, DbJudgeSymbol symbol, object value)
            : base(name)
        {
            this.Logical = logical;
            this.Value = value;
            this.Symbol = symbol;
            this.Safety = false;
            this.Aggrefunc = DbAggrefunc.NONE;
        }


        //internal object valueResult;
        public DbAggrefunc Aggrefunc { get; protected internal set; }

        /// <summary>
        /// 安全链接
        /// </summary>
        internal bool Safety { get; set; }

        public DbLogical Logical { get; protected internal set; }

        /// <summary>
        /// 对应的值
        /// </summary>
        public object Value { get; protected internal set; }

        /// <summary>
        /// 查询等式
        /// </summary>
        public DbJudgeSymbol Symbol { get; protected internal set; }
    }
}
