﻿using System;

namespace ThinkNet.Domain
{
    /// <summary>Represents an exception when tring to get a not existing aggregate root.
    /// </summary>
    public class AggregateRootNotFoundException : Exception
    {
        /// <summary>Parameterized constructor.
        /// </summary>
        /// <param name="id">The aggregate root id.</param>
        /// <param name="type">The aggregate root type.</param>
        public AggregateRootNotFoundException(object id, Type type) :
            base(string.Format(Resources.EX_AGGREGATE_CANNOT_FIND, type.Name, id)) 
        { }
    }
}
