﻿using System;
using System.Collections.Generic;

namespace ThinkNet.Domain
{
    /// <summary>
    /// 提供聚合根类型的提供者.
    /// </summary>
    public interface IAggregateRootTypeProvider
    {
        /// <summary>
        /// 根据聚合根类型获取聚合根类型名称。
        /// </summary>
        /// <returns></returns>
        string GetAggregateRootTypeName(Type aggregateRootType);
        /// <summary>
        /// 根据聚合根类型名称获取聚合根类型。
        /// </summary>
        /// <returns></returns>
        Type GetAggregateRootType(string name);
        /// <summary>
        /// 获取所有的聚合根类型
        /// </summary>
        /// <returns></returns>
        IEnumerable<Type> GetAllAggregateRootTypes();

        /// <summary>
        /// 根据聚合根类型创建一个空的聚合根实例
        /// </summary>
        /// <param name="aggregateRootType"></param>
        /// <returns></returns>
        IAggregateRoot CreateAggregateRoot(Type aggregateRootType);
    }
}
