﻿
namespace ThinkNet.Domain
{
    /// <summary>
    /// 设置或获取聚合根的缓存接口
    /// </summary>
    public interface ICache
    {
        /// <summary>
        /// 从缓存获取一个聚合根
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        ISourcedAggregateRoot Get(object id, System.Type type);
        ///// <summary>Get a strong type aggregate from memory cache.
        ///// </summary>
        ///// <typeparam name="T"></typeparam>
        ///// <param name="id"></param>
        ///// <returns></returns>
        //TAggregateRoot Get<TAggregateRoot>(object id) where TAggregateRoot : class, ISourcedAggregateRoot;
        ///// <summary>
        ///// Add an aggregate to memory cache.
        ///// </summary>
        ///// <param name="aggregateRoot"></param>
        //void Add(IAggregateRoot aggregateRoot);
        /// <summary>
        /// 设置一个聚合入缓存。不存在加入缓存，存在更新缓存
        /// </summary>
        /// <param name="aggregateRoot"></param>
        void Set(ISourcedAggregateRoot aggregateRoot);
        /// <summary>
        /// 从缓存中移除聚合根
        /// </summary>
        void Remove(object id, System.Type type);
        //void Remove<TAggregateRoot>(object id) where TAggregateRoot : class, ISourcedAggregateRoot;
    }
}
