﻿using ThinkNet.Infrastructure;

namespace ThinkNet.Domain
{
    /// <summary>
    /// 表示继承该接口的聚合根在持久化前可进行相关回调
    /// </summary>
    public interface ILifecycle
    {
        /// <summary>
        /// Save前回调
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        LifecycleVeto OnSave(IRepositoryContext context);
        /// <summary>
        /// Update前回调
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        LifecycleVeto OnUpdate(IRepositoryContext context);
        /// <summary>
        /// Delete前回调
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        LifecycleVeto OnDelete(IRepositoryContext context);
        ///// <summary>
        ///// Load后回调
        ///// </summary>
        ///// <param name="context"></param>
        //void OnLoad(IRepositoryContext context);
    }
}
