﻿using System;

namespace ThinkNet.Domain
{
    /// <summary>
    /// 存储快照
    /// </summary>
    public interface ISnapshotStore
    {
        /// <summary>
        /// 存储给定的快照。
        /// </summary>
        /// <param name="snapshot"></param>
        void SaveShapshot(Snapshot snapshot);
        /// <summary>
        /// 从存储中删除快照。
        /// </summary>
        /// <param name="aggregateRootId"></param>
        /// <param name="aggregateRootType"></param>
        void Remove(object aggregateRootId, Type aggregateRootType);
        /// <summary>
        /// 获取指定聚合根的最新快照。
        /// </summary>
        /// <param name="aggregateRootId">The aggregate root id.</param>
        /// <param name="aggregateRootType">The aggregate root type.</param>
        /// <returns>Returns the snapshot if exist; otherwise, returns null.</returns>
        Snapshot GetLastestSnapshot(object aggregateRootId, Type aggregateRootType);
    }
}
