﻿using System;
using System.Reflection;

namespace ThinkNet.Domain
{
    public class DefaultSnapshotTableNameProvider : ISnapshotTableNameProvider
    {
        private readonly IAggregateRootTypeProvider _aggregateRootTypeProvider;

        /// <summary>Parameterized constructor.
        /// </summary>
        /// <param name="aggregateRootTypeProvider"></param>
        public DefaultSnapshotTableNameProvider(IAggregateRootTypeProvider aggregateRootTypeProvider)
        {
            _aggregateRootTypeProvider = aggregateRootTypeProvider;
        }

        #region ISnapshotTableNameProvider 成员

        public string GetTable(Type aggregateRootType)
        {
            if (aggregateRootType.IsDefined(typeof(SnapshotTableNameAttribute), false)) {
                var attribute = aggregateRootType.GetAttribute<SnapshotTableNameAttribute>(false);

                return attribute.PerAggregate ? string.Concat("Snapshot_", aggregateRootType.Name) : attribute.TableName;
            }
            else {
                return "Snapshots";
            }
        }

        #endregion
    }
}
