﻿using System;

namespace ThinkNet.Domain
{
    /// <summary>Represents a snapshot store that always not store any snapshot.
    /// </summary>
    public class EmptySnapshotStore : ISnapshotStore
    {
        /// <summary>Do nothing.
        /// </summary>
        /// <param name="snapshot"></param>
        public virtual void SaveShapshot(Snapshot snapshot)
        {
        }

        /// <summary>Do nothing.
        /// </summary>
        public virtual void Remove(object aggregateRootId, Type aggregateRootType)
        {
        }

        /// <summary>Always return null.
        /// </summary>
        /// <param name="aggregateRootId"></param>
        /// <param name="aggregateRootType"></param>
        /// <returns></returns>
        public virtual Snapshot GetLastestSnapshot(object aggregateRootId, Type aggregateRootType)
        {
            return null;
        }
    }
}
