﻿using System;

namespace ThinkNet.Domain
{
    /// <summary>
    /// 聚合快照
    /// </summary>
    public class Snapshot
    {
        public Snapshot()
        { }

        /// <summary>Parameterized constructor.
        /// </summary>
        /// <param name="aggregateRootName"></param>
        /// <param name="aggregateRootId"></param>
        /// <param name="version"></param>
        /// <param name="data"></param>
        /// <param name="timestamp"></param>
        public Snapshot(string aggregateRootName, string aggregateRootId, int version, object data, DateTime timestamp)
        {
            this.AggregateRootName = aggregateRootName;
            this.AggregateRootId = aggregateRootId;
            this.Version = version;
            this.Data = data;
            this.Timestamp = timestamp;
        }

        /// <summary>
        /// 聚合根标识
        /// </summary>
        public string AggregateRootId { get; set; }
        /// <summary>
        /// 聚合根类型名称
        /// </summary>
        public string AggregateRootName { get; set; }
        /// <summary>
        /// 创建该聚合快照的聚合根版本号
        /// </summary>
        public int Version { get; set; }
        /// <summary>
        /// 聚合根数据
        /// </summary>
        public object Data { get; set; }
        /// <summary>
        /// 创建该快照的时间
        /// </summary>
        public DateTime Timestamp { get; set; }
    }
}
