﻿using System;

namespace ThinkNet.Domain
{
    /// <summary>
    /// 指定聚合根快照表名称的特性
    /// </summary>
    [AttributeUsage(AttributeTargets.Class)]
    public sealed class SnapshotTableNameAttribute : Attribute
    {
        public SnapshotTableNameAttribute()
        {
            this.PerAggregate = true;
        }

        public SnapshotTableNameAttribute(string tableName)
        {
            this.TableName = tableName;
            this.PerAggregate = false;
        }

        /// <summary>
        /// 存储快照的表名称
        /// </summary>
        public string TableName { get; private set; }
        /// <summary>
        /// 是否为每个聚合根的名称
        /// </summary>
        public bool PerAggregate { get; private set; }
    }
}
