﻿using System;

namespace ThinkNet.Event
{
    /// <summary>
    /// 指定存储事件的表名称的特性
    /// </summary>
    [AttributeUsage(AttributeTargets.Class)]
    public sealed class EventTableNameAttribute : Attribute
    {
        public EventTableNameAttribute()
        {
            this.PerAggregate = true;
        }

        public EventTableNameAttribute(string tableName)
        {
            this.TableName = tableName;
        }

        /// <summary>
        /// 存储事件的表名称
        /// </summary>
        public string TableName { get; private set; }

        /// <summary>
        /// 是否为每个聚合根的名称
        /// </summary>
        public bool PerAggregate { get; private set; }
    }
}
