﻿using System;

namespace ThinkNet.Event
{
    /// <summary>
    /// 存储事件处理器信息的接口
    /// </summary>
    public interface IEventHandleInfoStore
    {
        /// <summary>
        /// 存储事件处理器信息
        /// </summary>
        /// <param name="eventId"></param>
        /// <param name="eventHandlerTypeName"></param>
        void AddEventHandleInfo(Guid eventId, string eventHandlerTypeName);
        /// <summary>
        /// 检查该处理器信息是否存在
        /// </summary>
        /// <param name="eventId"></param>
        /// <param name="eventHandlerTypeName"></param>
        /// <returns></returns>
        bool IsEventHandleInfoExist(Guid eventId, string eventHandlerTypeName);
        /// <summary>
        /// 移除该处理器信息
        /// </summary>
        /// <param name="eventId"></param>
        void RemoveEventHandleInfo(Guid eventId);
    }
}
