﻿using System;
using System.Collections.Generic;

namespace ThinkNet.Event
{
    /// <summary>
    /// 表示一个事件存储。用来存储聚合内的事件
    /// </summary>
    public interface IEventStore
    {
        /// <summary>
        /// 追加事件流到存储
        /// </summary>
        void Append(EventStream stream);
        /// <summary>
        /// 删除相关的事件
        /// </summary>
        /// <param name="aggregateRootId"></param>
        /// <param name="aggregateRootType"></param>
        void Remove(object aggregateRootId, Type aggregateRootType);
        ///// <summary>
        ///// 检查事件是否已经存储
        ///// </summary>
        ///// <param name="aggregateRootId"></param>
        ///// <param name="aggregateRootType"></param>
        ///// <param name="id"></param>
        ///// <returns></returns>
        //bool IsEventStreamExist(string aggregateRootId, Type aggregateRootType, Guid id);
        /// <summary>
        /// 查询事件
        /// </summary>
        IEnumerable<EventStream> Query(object aggregateRootId, Type aggregateRootType, int minStreamVersion, int maxStreamVersion);
        /// <summary>
        /// 查询所有的事件
        /// </summary>
        /// <returns></returns>
        IEnumerable<EventStream> QueryAll();
    }
}
