﻿using System;
using System.Collections.Generic;

namespace ThinkNet.Event
{
    /// <summary>
    /// 提供存储事件表的名称的提供程序
    /// </summary>
    public interface IEventTableNameProvider
    {
        /// <summary>
        /// 获取给定的聚合根类型的表名称
        /// </summary>
        /// <param name="aggregateRootType"></param>
        /// <returns></returns>
        string GetTable(Type aggregateRootType);
        /// <summary>
        /// 获取所有存储事件的表名称。
        /// </summary>
        /// <returns></returns>
        IEnumerable<string> GetAllTables();
    }
}
