﻿using System.Collections;


namespace System.Data
{
    public static class DataReaderExtentions
    {
        public static IDictionary ToDictionary(this IDataReader reader)
        {
            return reader.ToDictionary(false);
        }

        public static IDictionary ToDictionary(this IDataReader reader, bool closedReader)
        {
            Hashtable ht = new Hashtable();

            for (int i = 0; i < reader.FieldCount; i++) {
                ht.Add(reader.GetName(i), reader.GetValue(i));
            }

            if (closedReader) reader.Close();

            return ht;
        }

        public static IList ToList(this IDataReader reader)
        {
            return reader.ToList(false);
        }

        public static IList ToList(this IDataReader reader, bool closedReader)
        {
            ArrayList list = new ArrayList();

            while (reader.Read()) {
                list.Add(ToDictionary(reader));
            }

            if (closedReader) reader.Close();

            return list;
        }
    }
}
