﻿

namespace ThinkNet.Infrastructure
{
    public static class ObjectContainerExtentions
    {
        public static IObjectContainer RegisterInstance<T>(this IObjectContainer that, object instance, LifetimeStyle lifetimeStyle)
        {
            return that.RegisterInstance(typeof(T), instance, lifetimeStyle);
        }

        public static IObjectContainer RegisterInstance<T>(this IObjectContainer that, string name, object instance, LifetimeStyle lifetimeStyle)
        {
            return that.RegisterInstance(typeof(T), instance, name, lifetimeStyle);
        }

        public static IObjectContainer RegisterType<T>(this IObjectContainer that, LifetimeStyle lifetimeStyle)
        {
            return that.RegisterType(typeof(T), lifetimeStyle);
        }

        public static IObjectContainer RegisterType<T>(this IObjectContainer that, string name, LifetimeStyle lifetimeStyle)
        {
            return that.RegisterType(typeof(T), name, lifetimeStyle);
        }

        public static IObjectContainer RegisterType<TFrom, TTo>(this IObjectContainer that, LifetimeStyle lifetime)
        {
            return that.RegisterType(typeof(TFrom), typeof(TTo), lifetime);
        }

        public static IObjectContainer RegisterType<TFrom, TTo>(this IObjectContainer that, string name, LifetimeStyle lifetime)
        {
            return that.RegisterType(typeof(TFrom), typeof(TTo), name, lifetime);
        }

        public static bool IsRegistered<T>(this IObjectContainer that)
        {
            return that.IsRegistered(typeof(T));
        }

        public static bool IsRegistered<T>(this IObjectContainer that, string name)
        {
            return that.IsRegistered(typeof(T), name);
        }
    }
}
