﻿
namespace System
{
    public static class ObjectExtentions
    {
        /// <summary>
        /// 名称为<paramref name="variableName"/>的参数或变量的值（<paramref name="obj"/>）不能是空引用。
        /// </summary>
        public static void MustNotNull(this object obj, string variableName)
        {
            if (obj == null)
                throw new ArgumentNullException(variableName);
        }

        /// <summary>
        /// 名称为<paramref name="variableName"/>的参数或变量的值（<paramref name="str"/>）不能是空引用或者空值。
        /// </summary>
        public static void MustNotEmpty(this string str, string variableName)
        {
            if (string.IsNullOrEmpty(str))
                throw new ApplicationException(variableName);
        }
    }
}
