﻿using System.Collections;

namespace ThinkNet.Infrastructure.Cache
{
    internal sealed class HashtableCache : ICache
    {
        private IDictionary hashtable = Hashtable.Synchronized(new Hashtable());

        public HashtableCache(string regionName)
        {
            this.RegionName = regionName;
        }

        #region ICache 成员

        public object Get(object key)
        {
            return hashtable[key];
        }

        public void Put(object key, object value)
        {
            hashtable[key] = value;
        }

        public void Remove(object key)
        {
            hashtable.Remove(key);
        }

        public void Clear()
        {
            hashtable.Clear();
        }

        public void Destroy()
        {
            hashtable.Clear();
        }

        public string RegionName
        {
            get;
            private set;
        }

        #endregion
    }
}
