﻿
namespace ThinkNet.Infrastructure.Cache
{
    public interface ICache
    {
        /// <summary>
        /// Get the object from the Cache
        /// </summary>
        /// <param name="key"></param>
        /// <returns></returns>
        object Get(object key);

        /// <summary>
        /// add the object to the cache
        /// </summary>
        /// <param name="key"></param>
        /// <param name="value"></param>
        void Put(object key, object value);

        /// <summary>
        /// Remove an item from the Cache.
        /// </summary>
        /// <param name="key">The Key of the Item in the Cache to remove.</param>
        /// <exception cref="CacheException"></exception>
        void Remove(object key);

        /// <summary>
        /// Clear the Cache
        /// </summary>
        /// <exception cref="CacheException"></exception>
        void Clear();

        /// <summary>
        /// Clean up.
        /// </summary>
        /// <exception cref="CacheException"></exception>
        void Destroy();

        /// <summary>
        /// Gets the name of the cache region
        /// </summary>
        string RegionName { get; }
    }
}
