﻿using System;
using System.Collections.Generic;

namespace ThinkNet.Infrastructure.Cache
{
    /// <summary>
    /// Support for pluggable caches
    /// </summary>
    public interface ICacheProvider
    {
        /// <summary>
        /// Configure the cache
        /// </summary>
        /// <param name="regionName">the name of the cache region</param>
        /// <param name="properties">configuration settings</param>
        /// <returns></returns>
        ICache BuildCache(string regionName, IDictionary<string, string> properties);

        /// <summary>
        /// generate a timestamp
        /// </summary>
        /// <returns></returns>
        long NextTimestamp();
    }
}
