﻿using System.Collections.Generic;

namespace ThinkNet.Infrastructure.Cache
{
    public class WebCacheConfig
    {
        private readonly Dictionary<string, string> properties;

        private readonly string regionName;



        /// <summary>
        /// build a configuration
        /// </summary>
        /// <param name="region"></param>
        /// <param name="expiration"></param>
        /// <param name="priority"></param>
        public WebCacheConfig(string region, string expiration, string priority)
        {
            regionName = region;

            properties = new Dictionary<string, string> { { "expiration", expiration }, { "priority", priority } };
        }


        public string Region
        {
            get { return regionName; }
        }


        public IDictionary<string, string> Properties
        {
            get { return properties; }
        }
    }
}
