﻿using System;
using System.Web.Script.Serialization;

namespace ThinkNet.Infrastructure
{
    public class DefaultJsonSerializer : IStringSerializer
    {
        JavaScriptSerializer jsonSerializer = new JavaScriptSerializer(new CustomTypeResolver());

        public string Serialize(object obj)
        {
            return jsonSerializer.Serialize(obj);
        }

        public object Deserialize(string value)
        {
            return jsonSerializer.DeserializeObject(value);
        }

        public T Deserialize<T>(string value) where T : class
        {
            return jsonSerializer.Deserialize<T>(value);
        }


        class CustomTypeResolver : JavaScriptTypeResolver
        {
            public override Type ResolveType(string id)
            {
                return Type.GetType(id, false, true);
            }

            public override string ResolveTypeId(Type type)
            {
                return string.Concat(type.FullName, ", ", type.Assembly.GetName().Name);
            }
        }
    }


}
