﻿
namespace ThinkNet.Infrastructure
{
    /// <summary>
    /// 表示一个序列化器。用来序列化对象的字节数组
    /// </summary>
    public interface IBinarySerializer
    {
        /// <summary>
        /// 序列化一个对象到字节数组。
        /// </summary>
        byte[] Serialize(object obj);
        /// <summary>
        /// 反序列化一个对象从一个字节数组。
        /// </summary>
        object Deserialize(byte[] data);
        /// <summary>
        /// 反序列化一个对象类型从一个字节数组。
        /// </summary>
        T Deserialize<T>(byte[] data) where T : class;
    }
}
