﻿
namespace ThinkNet.Infrastructure
{
    /// <summary>
    /// 表示一个序列化器。用来序列化对象的字符串
    /// </summary>
    public interface IStringSerializer
    {
        /// <summary>
        /// 序列化一个对象到字符串。
        /// </summary>
        string Serialize(object obj);
        /// <summary>
        /// 从字符串反序列化一个对象。
        /// </summary>
        object Deserialize(string data);
        /// <summary>
        /// 从字符串反序列化一个对象类型。
        /// </summary>
        T Deserialize<T>(string data) where T : class;
    }
}
