﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Linq.Expressions;

namespace ThinkNet.Infrastructure
{
    public interface ISort<T>
    {
        /// <summary>
        /// 排序
        /// </summary>
        IEnumerable<ISortItem<T>> Sorters { get; }

        /// <summary>
        /// 排列计算
        /// </summary>
        /// <param name="enumerable"></param>
        /// <returns></returns>
        IQueryable<T> Arranged(IQueryable<T> enumerable);
    }

    public interface ISortItem<T>
    {
        /// <summary>
        /// 获取排序lambda表达式
        /// </summary>
        Expression<Func<T, object>> Expression { get; }

        /// <summary>
        /// 获取排序方式
        /// </summary>
        SortOrder SortOrder { get; }
    }
}
