﻿using System;

namespace ThinkNet.Infrastructure
{
    public class ThinkNetException : Exception
    {
        /// <summary>Default constructor.
        /// </summary>
        public ThinkNetException() { }
        /// <summary>Parameterized constructor.
        /// </summary>
        /// <param name="message"></param>
        public ThinkNetException(string message) : base(message) { }
        /// <summary>Parameterized constructor.
        /// </summary>
        /// <param name="message"></param>
        /// <param name="innerException"></param>
        public ThinkNetException(string message, Exception innerException) : base(message, innerException) { }
        /// <summary>Parameterized constructor.
        /// </summary>
        /// <param name="message"></param>
        /// <param name="args"></param>
        public ThinkNetException(string message, params object[] args) : base(string.Format(message, args)) { }
    }
}
