﻿
namespace ThinkNet.Messaging
{
    /// <summary>
    /// 消息处理器接口
    /// </summary>
    public interface IMessageExecutor<TMessage, TMessageQueue> 
        where TMessage : class, IMessage
        where TMessageQueue : IMessageQueue<TMessage>
    {
        /// <summary>
        /// 执行给定的队列消息。
        /// </summary>
        /// <param name="message"></param>
        /// <param name="queue"></param>
        /// <returns></returns>
        void Execute(TMessage message, TMessageQueue queue);
    }
}
