﻿
namespace ThinkNet.Messaging
{
    ///// <summary>Represents a message processor.
    ///// </summary>
    //public interface IMessageProcessor
    //{
    //    /// <summary>Represents the binding message queue.
    //    /// </summary>
    //    IMessageQueue BindingQueue { get; }
    //    /// <summary>Initialize the message processor.
    //    /// </summary>
    //    void Initialize();
    //    /// <summary>Start the message processor, and it will start to fetch message from the binding message queue.
    //    /// </summary>
    //    void Start();
    //}


    /// <summary>
    /// 消息处理器
    /// </summary>
    public interface IMessageProcessor<out TQueue, TMessage>
        where TQueue : class, IMessageQueue<TMessage>
        where TMessage : class, IMessage
    {
        /// <summary>
        /// 绑定的消息队列
        /// </summary>
        TQueue BindingQueue { get; }
        /// <summary>
        /// 初始化消息处理器
        /// </summary>
        void Initialize();
        /// <summary>
        /// 启动消息处理器。它将开始从绑定的消息队列获取消息。
        /// </summary>
        void Start();
    }
}
